package example.workeraggregation;

public class Worker2 extends Worker
{
	private int chainSize;
	public Worker2(int workerIndex)
	{
		super(workerIndex);
		chainSize =0;
	}
	
	public void setCoWorker(Worker coWorker, int chainSize)
	{
		super.setCoWorker(coWorker);
		this.chainSize = chainSize;
	}
	
	@Override
	public void run()
	{
		lock();
		System.out.println("Thread " + getName()+ " started ...");
		
		boolean coOptedWorker=false;
		try
		{
			//simulate some work			
			Thread.sleep(1000 *workerIndex);
			if (coWorker!=null && chainSize<2)
			{
				coWorker.lock();
				coOptedWorker=true;
				System.out.println("Thread " + getName()+ 
									" co-opted co-worker " + 
									coWorker.getName());
			}
			else System.out.println(getName() + " working solo today...");
		}
		catch (InterruptedException exce)
		{
			return;
		}
		finally
		{
			if (coOptedWorker)coWorker.unlock();			
			unlock();
		}
	}
}